--- linux/include/asm-arm/arch-sa1100/time.h	Tue Mar 14 11:13:53 2000
+++ hijack/include/asm-arm/arch-sa1100/time.h	Mon Mar  4 18:18:01 2002
@@ -41,7 +41,7 @@
 	/* Time at which we can safely set a timer match interrupt - not too
 	   close to current time for safety */
 	const unsigned long safeperiod = 2;
-	unsigned long safetime = OSCR+safeperiod;
+	unsigned long safetime;
 
 	/* Disable IRQs during this timer update: this is done because
 	   previously problems could occur with an IRQ from another source
@@ -49,7 +49,7 @@
 	   been passed by the time the OSMR was written to.
 	   hugo@empeg.com
         */
-	save_flags_cli(flags);
+	save_flags_clif(flags);
 	last_os_timer_match=OSMR0;
 
         /* Clear match on timer 0 */
@@ -67,7 +67,7 @@
 		break;
 #endif
 
-	while (((next_os_timer_match >= safetime) && (next_os_timer_match - safetime > 0x80000000))
+	while (((next_os_timer_match >= (safetime = OSCR+safeperiod)) && (next_os_timer_match - safetime > 0x80000000))
 	       || ((next_os_timer_match < safetime) && (safetime - next_os_timer_match < 0x80000000))) {
 		/* Too close to next interrupt, back off one. Reset last_os_timer_match to
 		   the timer value which we would have set if it wasn't too close as we've
